//#version 120
#extension GL_OES_EGL_image_external : require
precision highp float;

varying vec2 vTextureCoord;
varying vec2 vExtraTextureCoord;

uniform samplerExternalOES uTexture;
uniform sampler2D uExtraTexture;

 void main(){
//     vec2 st  = vTextureCoord;
//     vec4 tc  = texture2D(uTexture,st);
//     vec4 front = texture2D(uTexture,st);
//     vec4 front_a = texture2D(uTexture,st,8.5849625);
//     front-=front_a-(front_a[0]+front_a[1]+front_a[2])/3.0;
//     front = mix(tc,front,0.1);

     vec3 centralColor;
     float sampleColor;
     vec4 outputColor;
     vec4 base;
     vec2 blurCoordinates[12];
     float mul = 2.0;
     float mul_x = mul / 720.0;
     float mul_y = mul / 1280.0;
    vec2 singleStepOffset= vec2(mul_x,mul_y);
	blurCoordinates[0] = vTextureCoord.xy + singleStepOffset * vec2(5.0, -8.0);
	blurCoordinates[1] = vTextureCoord.xy + singleStepOffset * vec2(5.0, 8.0);
	blurCoordinates[2] = vTextureCoord.xy + singleStepOffset * vec2(-5.0, 8.0);
	blurCoordinates[3] = vTextureCoord.xy + singleStepOffset * vec2(-5.0, -8.0);

	blurCoordinates[4] = vTextureCoord.xy + singleStepOffset * vec2(8.0, -5.0);
	blurCoordinates[5] = vTextureCoord.xy + singleStepOffset * vec2(8.0, 5.0);
	blurCoordinates[6] = vTextureCoord.xy + singleStepOffset * vec2(-8.0, 5.0);
	blurCoordinates[7] = vTextureCoord.xy + singleStepOffset * vec2(-8.0, -5.0);

	blurCoordinates[8] = vTextureCoord.xy + singleStepOffset * vec2(-4.0, -4.0);
	blurCoordinates[9] = vTextureCoord.xy + singleStepOffset * vec2(-4.0, 4.0);
	blurCoordinates[10] = vTextureCoord.xy + singleStepOffset * vec2(4.0, -4.0);
	blurCoordinates[11] = vTextureCoord.xy + singleStepOffset * vec2(4.0, 4.0);

//     sampleColor = front.g * 22.0;
     sampleColor = texture2D(uTexture, vTextureCoord).g * 22.0;

     sampleColor += texture2D(uTexture, blurCoordinates[0]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[1]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[2]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[3]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[4]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[5]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[6]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[7]).g;
     sampleColor += texture2D(uTexture, blurCoordinates[8]).g * 2.0;
     sampleColor += texture2D(uTexture, blurCoordinates[9]).g * 2.0;
     sampleColor += texture2D(uTexture, blurCoordinates[10]).g* 2.0;
     sampleColor += texture2D(uTexture, blurCoordinates[11]).g* 2.0;

     sampleColor = sampleColor / 38.0;


//     centralColor = front.rgb;
    centralColor = texture2D(uTexture, vTextureCoord).rgb;

    lowp float r = centralColor.r;
    lowp float g = centralColor.g;
    lowp float b = centralColor.b;
    if (r > 0.3725 && g > 0.1568 && b > 0.0784 && r > b && (max(max(r, g), b) - min(min(r, g), b)) > 0.0588 && abs(r-g) > 0.0588)
    {

         float dis = centralColor.g - sampleColor + 0.5;


         if(dis <= 0.5)
         {
             dis = dis * dis * 2.0;
         }
         else
         {
             dis = 1.0 - ((1.0 - dis)*(1.0 - dis) * 2.0);
         }

         if(dis <= 0.5)
         {
             dis = dis * dis * 2.0;
         }
         else
         {
             dis = 1.0 - ((1.0 - dis)*(1.0 - dis) * 2.0);
         }

         if(dis <= 0.5)
         {
             dis = dis * dis * 2.0;
         }
         else
         {
             dis = 1.0 - ((1.0 - dis)*(1.0 - dis) * 2.0);
         }

         if(dis <= 0.5)
         {
             dis = dis * dis * 2.0;
         }
         else
         {
             dis = 1.0 - ((1.0 - dis)*(1.0 - dis) * 2.0);
         }

         if(dis <= 0.5)
         {
             dis = dis * dis * 2.0;
         }
         else
         {
             dis = 1.0 - ((1.0 - dis)*(1.0 - dis) * 2.0);
         }


         float aa= 1.03;
         vec3 smoothColor = centralColor*aa - vec3(dis)*(aa-1.0);

         float hue = dot(smoothColor, vec3(0.299,0.587,0.114));

         aa = 1.0 + pow(hue, 0.6)*0.1;
         smoothColor = centralColor*aa - vec3(dis)*(aa-1.0);

         smoothColor.r = clamp(pow(smoothColor.r, 0.8),0.0,1.0);
         smoothColor.g = clamp(pow(smoothColor.g, 0.8),0.0,1.0);
         smoothColor.b = clamp(pow(smoothColor.b, 0.8),0.0,1.0);


     mat3 saturateMatrix = mat3(1.1102,-0.0598,-0.061,
                                -0.0774,1.0826,-0.1186,
                                -0.0228,-0.0228,1.1772);

     vec3 satcolor = smoothColor * saturateMatrix;
     base.rgb = mix(smoothColor, satcolor, 0.05);
     base.a = 1.0;
     vec4 overlay = texture2D(uExtraTexture, vExtraTextureCoord);
     gl_FragColor = base * (overlay.a * (base / base.a) + (2.0 * overlay * (1.0 - (base / base.a)))) + overlay * (1.0 - base.a) + base * (1.0 - overlay.a);
    }
    else
    {
        outputColor.rgb = centralColor;
        outputColor.r = clamp(pow(outputColor.r, 0.8),0.0,1.0);
        outputColor.g = clamp(pow(outputColor.g, 0.8),0.0,1.0);
        outputColor.b = clamp(pow(outputColor.b, 0.8),0.0,1.0);

        base.rgb = outputColor.rgb;
        base.a   = 1.0;
        vec4 overlay = texture2D(uExtraTexture, vExtraTextureCoord);
        gl_FragColor = base * (overlay.a * (base / base.a) + (2.0 * overlay * (1.0 - (base / base.a)))) + overlay * (1.0 - base.a) + base * (1.0 - overlay.a);

    }
}